(function(){
var GameSDK = window.GameSDK = {
                // CallBack
                callBacks: {},
                // Internal -- Call Native
                callNative: function (cmd, param) {
                    console.log(cmd+"============================================================================================================================");
                    if(cmd=="ad_rewardedVideo_create") {
                        console.log(JSON.stringify(param));
                      //  window.AndroidMethod.loadVideoAd(JSON.stringify(param));
                    }else if(cmd=="ad_rewardedVideo_show"){
                     //   window.AndroidMethod.playVideoAd(JSON.stringify(param));
                    }
                },

                nativeCallback: function (cmd, param) {
                    var func = this.callBacks[cmd];
                    if (func) {
                        func(JSON.parse(param));
                    }
                },

                registerCallback: function (cmd, func) {
                    this.callBacks[cmd] = func;
                },

                // 设置回调函数
                setOnInitCB: function (func) {
                    this.registerCallback("onInit", func);
                },

                setOnRoomInfoCB: function (func) {
                    this.registerCallback("onRoomInfo", func);
                },

                setOnReadyCB: function (func) {
                    this.registerCallback("onReady", func);
                },

                setOnStartCB: function (func) {
                    this.registerCallback("onStart", func);
                },

                setOnMessageCB: function (func) {
                    this.registerCallback("onMessage", func);
                },

                setOnFinishCB: function (func) {
                    this.registerCallback("onFinish", func);
                },

                setOnAudioCB: function (func) {
                    this.registerCallback("onAudio", func);
                },

                setOnResumeCB: function (func) {
                    this.registerCallback("onResume", func);
                },

                setOnPauseCB: function (func) {
                    this.registerCallback("onPause", func);
                },

                setOnPayCB : function( func ){
                    this.registerCallback("onPay", func);
                },

                // 初始化SDK
                // 参数:
                //   gameId: int 游戏ID
                init: function (gameId) {
                    var param = {
                        "gameId": gameId
                    };
                    this.callNative("init", param);
                },

                // 退出游戏
                // 参数:
                //   reason: int 退出原因: 1 - 正常退出，2-异常退出
                quit: function (reason) {
                    var param = {
                        "reason": reason
                    };
                    this.callNative("quit", param);
                },


                // 获取游戏房间信息
                getRoomInfo: function () {
                    this.callNative("getRoomInfo");
                },

                // 游戏终止
                // 参数:
                //   result: int 游戏结果: 1、胜，2、负，3、平
                finish: function (result) {
                    var param = {
                        "result": result
                    };
                    this.callNative("finish", param);
                },

                // 设置屏幕朝向
                // 参数:
                //    orientation: int 屏幕朝向: 0、横屏，1、竖屏
                setOrientation: function (orientation) {
                    var param = {
                        "orientation": orientation
                    };
                    this.callNative("setOrientation", param);
                },

                // 设置声音
                // 参数:
                //   enable: int 是否开启: 0、关闭，1、开启
                //   volume: int 音量
                setAudio: function (enable, volume) {
                    var param = {
                        "enable": enable,
                        "volume": volume
                    };
                    this.callNative("setAudio", param);
                },

                // 设置麦克风
                // 参数:
                //   enable: int 是否开启: 0、关闭，1、开启
                //   volume: int 音量: 0 ~ 100
                setMic: function (enable, volume) {
                    var param = {
                        "enable": enable,
                        "volume": volume
                    };
                    this.callNative("setMic", param);
                },

                // 设置游戏加载进度（SDK版本 >= 2）
                // 参数:
                //    progress: int 加载进度: 0 ~ 100
                // 说明: 从SDK版本2开始，平台增加了统一的游戏加载进度界面，用于游戏后台加载时显示。
                //      游戏需要在初始化后，通过此函数报告游戏加载进度。加载界面将显示“加载中...”
                //      当进度>=100%时，加载界面并不会关闭，加载界面将提醒用户“等待对手进入中...”
                //      因此，游戏需要在对手都进入房间后，调用hideLoadProgress函数关闭加载界面。
                setLoadProgress: function (progress) {
                    var param = {
                        "progress": progress
                    };
                    this.callNative("setLoadProgress", param);
                },

                // 隐藏游戏加载进度（SDK版本 >= 2）
                // 参数:
                //    无
                // 说明: 用于关闭加载进度界面。此后玩家才可以和游戏交互。
                hideLoadProgress: function () {
                    var param = {};
                    this.callNative("hideLoadProgress", param);
                },

                // 游戏准备
                // 参数
                //   userData: string 用户数据
                ready: function (userData) {
                    var param = {
                        "userData": userData
                    }
                    this.callNative("ready", param);
                },

                // 游戏消息广播
                // 参数
                //  message: string 广播的消息
                //  includeMe: int 是否也广播给自己: 0、不包含，1、包含
                broadcast: function (message, includeMe) {
                    if (includeMe == null) {
                        includeMe = 0;
                    }
                    var param = {
                        "message": message,
                        "includeMe": includeMe
                    }
                    this.callNative("broadcast", param);
                },

                // 游戏结束
                // 参数
                //   result: int 游戏结果: 1、胜，2、负，3、平
                gameOver: function (result) {
                    var param = {
                        "result": result,
                    }
                    this.callNative("gameOver", param);
                },

                // 游戏支付
                // 参数
                //   orderId: int 订单号
                //   goodsName: string 商品名称
                //   goodsDesc: string 商品描述
                //   orderAmount: int 订单金额
                //   extension： string 透传参数
                //   notifyURL: string 支付付款通知地址
                pay: function (orderId, goodsName, goodsDesc, orderAmount, extension, notifyURL) {
                    var param = {
                        "orderId": orderId,
                        "goodsName": goodsName,
                        "goodsDesc": goodsDesc,
                        "orderAmount": orderAmount,
                        "extension": extension,
                        "notifyURL": notifyURL
                    }
                    this.callNative("pay", param);
                },
            }


        var AdSDK = window.AdSDK = {
            bannerAds: {},
            interstitialAds: {},
            videoAds: {},
            init: function () {
                var self = this;
                GameSDK.registerCallback("ad_banner_onLoad", function (param) {
                    var banner = self.bannerAds[param.adId];
                    if (banner && banner.onLoad) {
                        banner.onLoad(param);
                    }
                });
                GameSDK.registerCallback("ad_banner_onError", function (param) {
                    var banner = self.bannerAds[param.adId];
                    if (banner && banner.onError) {
                        banner.onError(param);
                    }
                });
                GameSDK.registerCallback("ad_banner_onResize", function (param) {
                    var banner = self.bannerAds[param.adId];
                    if (banner && banner.onResize) {
                        banner.onResize(param);
                    }
                });
                GameSDK.registerCallback("ad_interstitial_onLoad", function (param) {
                    var interstitialAd = self.interstitialAds[param.adId];
                    if (interstitialAd && interstitialAd.onLoad) {
                        interstitialAd.onLoad(param);
                    }
                });
                GameSDK.registerCallback("ad_interstitial_onError", function (param) {
                    var interstitialAd = self.interstitialAds[param.adId];
                    if (interstitialAd && interstitialAd.onError) {
                        interstitialAd.onError(param);
                    }
                });
                GameSDK.registerCallback("ad_interstitial_onResize", function (param) {
                    var interstitialAd = self.interstitialAds[param.adId];
                    if (interstitialAd && interstitialAd.onResize) {
                        interstitialAd.onResize(param);
                    }
                });
                GameSDK.registerCallback("ad_rewardedVideo_onLoad", function (param) {
                    var videoAd = self.videoAds[param.adId];
                    if (videoAd && videoAd.onLoad) {
                        videoAd.onLoad(param);
                    }
                });
                GameSDK.registerCallback("ad_rewardedVideo_onError", function (param) {
                    var videoAd = self.videoAds[param.adId];
                    if (videoAd && videoAd.onError) {
                        videoAd.onError(param);
                    }
                });
                GameSDK.registerCallback("ad_rewardedVideo_onClose", function (param) {
                    var videoAd = self.videoAds[param.adId];
                    if (videoAd && videoAd.onClose) {
                        videoAd.onClose(param);
                    }
                });
                GameSDK.registerCallback("ad_onShow", function (param) {
                    if (param.type == 1) {
                        var banner = self.bannerAds[param.adId];
                        if( banner && banner.mHandler ){
                            banner.mHandler(param.success);
                        }
                    } else if (param.type == 2) {
                        var interstitialAd = self.interstitialAds[param.adId];
                        if( interstitialAd && interstitialAd.mHandler ){
                            interstitialAd.mHandler(param.success);
                        }
                    } else if (param.type == 3) {
                        var videoAd = self.videoAds[param.adId];
                        if( videoAd && videoAd.mHandler ){
                            videoAd.mHandler(param.success);
                        }
                    }
                });
            },
            // 创建Banner广告
            // 参数
            //   adId: string 广告序号ID
            //   bannerAdId: string Banner广告ID
            //   position: int 广告位置 1 屏幕顶部 2 屏幕底部 3屏幕中间
            createBannerAd : function (adId, bannerAdId, position) {
                var self = this;
                var bannerAd = {"adId": adId};
                var param = {
                    "adId": adId,
                    "bannerAdId": bannerAdId,
                    "position": position,
                };
                GameSDK.callNative("ad_banner_create", param);

                //显示 banner 广告
                bannerAd.show = function () {
                    var param = {
                        "adId": adId
                    };
                    GameSDK.callNative("ad_banner_show", param);
                    var promise = new Promise(function (resolve, reject) {
                        var handler = function (params) {
                            if (params == 0) {
                                resolve();
                            } else {
                                reject();
                            }
                        };
                        self.bannerAds[adId].mHandler = handler;
                    });
                    return promise;
                };
                //隐藏 banner 广告
                bannerAd.hide = function () {
                    var param = {
                        "adId": adId
                    };
                    GameSDK.callNative("ad_banner_hide", param);
                };

                // 销毁 banner 广告
                bannerAd.destroy = function () {
                    var param = {
                        "adId": adId
                    };
                    self.bannerAds[adId] = null;
                    GameSDK.callNative("ad_banner_destroy", param);
                };

                //监听 banner 广告加载事件
                bannerAd.onLoad = function (cb) {
                    this.onLoad = cb;
                };

                //监听 banner 广告错误事件
                bannerAd.onError = function (cb) {
                    this.onError = cb;
                };

                //监听 banner 广告尺寸变化事件  未实现
                bannerAd.onResize = function (cb) {
                    this.onResize = cb;
                };

                //取消监听 banner 广告加载事件
                bannerAd.offLoad = function (cb) {
                    if( this.onLoad == cb ){
                        this.onLoad = null;
                    }
                };

                //取消监听 banner 广告错误事件
                bannerAd.offError = function (cb) {
                    if( this.onError == cb ){
                        this.onError = null;
                    }
                };

                //取消监听 banner 广告尺寸变化事件
                bannerAd.offResize = function (cb) {
                    if( this.onResize == cb ){
                        this.onResize = null;
                    }
                };
                self.bannerAds[adId] = bannerAd;
                return bannerAd;
            },
            // 创建插屏广告
            // 参数
            //   adId: string 广告序号ID
            //   interstitialAdId: string 插屏广告ID
            //   style: int 广告类型 1 全屏 2 半屏
            createInterstitialAd : function (adId, interstitialAdId, style) {
                var self = this;
                var interstitialAd = {"adId": adId};
                var param = {
                    "adId": adId,
                    "interstitialAdId": interstitialAdId,
                    "style": style,
                };
                GameSDK.callNative("ad_interstitial_create", param);

                //显示 插屏 广告
                interstitialAd.show = function () {
                    var param = {
                        "adId": adId
                    };
                    GameSDK.callNative("ad_interstitial_show", param);
                    var promise = new Promise(function (resolve, reject) {
                        var handler = function (params) {
                            if (params == 0) {
                                resolve();
                            } else {
                                reject();
                            }
                        };
                        self.interstitialAds[adId].mHandler = handler;
                    });
                    return promise;
                };

                // 隐藏 插屏 广告
                interstitialAd.hide = function () {
                    var param = {
                        "adId": adId
                    };
                    GameSDK.callNative("ad_interstitial_hide", param);
                };

                // 销毁 插屏 广告
                interstitialAd.destroy = function () {
                    var param = {
                        "adId": adId
                    };
                    self.interstitialAds[adId] = null;
                    GameSDK.callNative("ad_interstitial_destroy", param);
                };

                // 监听 插屏 广告加载事件
                interstitialAd.onLoad = function (cb) {
                    this.onLoad = cb;
                };

                // 监听 插屏 广告错误事件
                interstitialAd.onError = function (cb) {
                    this.onError = cb;
                };
                // 监听 插屏 广告尺寸变化事件
                interstitialAd.onResize = function (cb) {
                    this.onResize = cb;
                };

                //取消监听 插屏 广告加载事件
                interstitialAd.offLoad = function (cb) {
                    if( this.onLoad == cb ){
                        this.onLoad = null;
                    }
                };

                //取消监听 插屏 广告错误事件
                interstitialAd.offError = function (cb) {
                    if( this.onError == cb ){
                        this.onError = null;
                    }
                };

                //取消监听 插屏 广告尺寸变化事件
                interstitialAd.offResize = function (cb) {
                    if( this.onResize == cb ){
                        this.onResize = null;
                    }
                };
                self.interstitialAds[adId] = interstitialAd;
                return interstitialAd;
            },
            // 创建激励视频广告
            // 参数
            //   videoAdId: string 视频广告ID
            //   screenOrientation: int 广告类型 1 横屏 2 竖屏
            createRewardedVideoAd : function (adId, videoAdId, screenOrientation) {
                var self = this;
                var rewardedVideoAd = {"adId": adId};
                var param = {
                    "adId": adId,
                    "videoAdId": videoAdId,
                    "screenOrientation": screenOrientation,
                };
                GameSDK.callNative("ad_rewardedVideo_create", param);

                //显示激励视频广告
                rewardedVideoAd.show = function () {
                    var param = {
                        "adId": adId
                    };
                    GameSDK.callNative("ad_rewardedVideo_show", param);
                    var promise = new Promise(function (resolve, reject) {
                        var handler = function (params) {
                            if (params == 0) {
                                resolve();
                            } else {
                                reject();
                            }
                        };
                        self.videoAds[adId].mHandler = handler;
                    });
                    return promise;
                };

                // 隐藏激励视频广告
                rewardedVideoAd.hide = function () {
                    var param = {
                        "adId": adId
                    };
                    GameSDK.callNative("ad_rewardedVideo_hide", param);
                };

                // 销毁激励视频广告
                rewardedVideoAd.destroy = function () {
                    var param = {
                        "adId": adId
                    };
                    self.videoAds[adId] = null;
                    GameSDK.callNative("ad_rewardedVideo_destroy", param);
                };

                //监听激励视频广告加载事件
                rewardedVideoAd.onLoad = function (cb) {
                    this.onLoad = cb;
                };

                //监听激励视频错误事件
                rewardedVideoAd.onError = function (cb) {
                    this.onError = cb;
                };

                //监听用户点击 关闭广告 按钮的事件
                rewardedVideoAd.onClose = function (cb) {
                    this.onClose = cb;
                };

                //监听激励视频广告加载事件
                rewardedVideoAd.offLoad = function (cb) {
                    if( this.onLoad == cb ){
                        this.onLoad = null;
                    }
                };

                //监听激励视频错误事件
                rewardedVideoAd.offError = function (cb) {
                    if( this.onError == cb ){
                        this.onError = null;
                    }
                };

                //监听用户点击 关闭广告 按钮的事件
                rewardedVideoAd.offClose = function (cb) {
                    if( this.onClose == cb ){
                        this.onClose = null;
                    }
                };
                self.videoAds[adId] = rewardedVideoAd;
                return rewardedVideoAd;
            }
        };
	window.HUHU = {
		gameId : 686099393,
		interstitialId : "670283159",
		videoId : "603758291",
		interstitialAd : {},
		videoAd : {},
		interstitialAdLoaded : false,
		videoAdLoaded : false,
		idRewarded : false,
		orientation : 1, 
	 };
	 window.HUHU_init = function(opt){
		try{
			console.log("HUHU_init");
			if(typeof(opt) != "undefined" && typeof(opt.orientation) != "undefined"){
				HUHU.orientation = opt.orientation;
			}
			//设置初始化回调函数
			GameSDK.setOnInitCB(HUHU_onInit);
			//设置平台进入前台回调函数
			//GameSDK.setOnResumeCB(this.onResume);
			//设置平台进入后台回调函数
			//GameSDK.setOnPauseCB(this.onPause);
			//设置平台声音控制回调函数
			//GameSDK.setOnAudioCB(this.onAudio);
			//初始化GameSDK
			GameSDK.init(HUHU.gameId);
			//设置平台横竖屏
			GameSDK.setOrientation(HUHU.orientation);
			//初始化AdSDK,依赖GameSDK
			AdSDK.init();
			console.log("init end!");
		}catch(e){
			console.log(e);
		}
	};
	
	//平台收到游戏init初始化后，会通过该函数回传用户信息
	//    error,  // int 错误代码：0、成功（见文末）
	//    userId,  // int当前玩家id
	//    nickName,  // string当前玩家名称
	//    headUrl,  // string 当前玩家头像地址
	//    location,  //string当前玩家地址
	//    sex,  // string 玩家性别："f" - 女；"m" - 男；"x" – 未知
	//    age // int 当前玩家年龄
	window.HUHU_onInit = function(param){
		console.log("onInit:", "userId "+ param.userId+" nickName "+ param.nickName+ " headUrl "+param.headUrl+" age "+param.age);
	};
	window.HUHU_quit = function(){
		GameSDK.quit(1);
	};
	//平台进入前台，通过该函数通知游戏
	window.HUHU_onResume = function(){
		console.log("onResume:");
	};
	//平台进入后台，通过该函数通知游戏
	window.HUHU_onPause = function(){
		console.log("onPause:");
	};
		// 创建插屏广告 展示一次调用一次创建
		// 参数
		//   adId: string 广告序号ID 游戏自定义
		//   interstitialAdId: string 插屏广告ID 需后台申请
		//   style: int 广告类型 1 全屏 2 半屏
	window.HUHU_createInterstitialAd = function(){
		try{
			console.log("HUHU_createInterstitialAd:");
			HUHU.interstitialAd = AdSDK.createInterstitialAd("1", HUHU.interstitialId, 1);
			//注册onLoad函数,游戏调用创建插屏时，AdSDK通知平台创建广告，当创建成功，会执行该回调函数通知游戏
			HUHU.interstitialAd.onLoad(function () {
				HUHU.interstitialAdLoaded=true;
				console.log("interstitialAd 创建插屏成功，可以调用展示");
			});
			 //注册onError函数,游戏调用创建插屏时，AdSDK通知平台创建广告，当创建失败，会执行该回调函数通知游戏
			HUHU.interstitialAd.onError(function (param) {
				console.log("interstitialAd 创建插屏失败，错误码 = ", param.errorCode);
				HUHU_destroyInterstitialAd();//加载广告失败，销毁
				//HUHU_createInterstitialAd();//预加载
			});
			console.log("interstitialAd 游戏创建插屏广告");
		}catch(e){
			console.log(e);
		}
	};
	window.HUHU_showInterstitialAd = function(){
		console.log("HUHU_showInterstitialAd:");
		if(HUHU.interstitialAdLoaded){
			HUHU.interstitialAd.show().then(function () {
				console.log("interstitialAd 广告显示成功,可给与奖励")
				HUHU_destroyInterstitialAd();//展示成功后，销毁
				HUHU_createInterstitialAd();//预加载
			}, function (err) {
				console.log("interstitialAd 广告显示失败")
				HUHU_createInterstitialAd();//预加载
			})
			console.log("interstitialAd 游戏展示插屏广告");
		}else{
			console.log("interstitialAd 广告未加载成功");
			HUHU_createInterstitialAd();//预加载
		}
	};
	window.HUHU_destroyInterstitialAd = function(){
		HUHU.interstitialAdLoaded=false;
		HUHU.interstitialAd.destroy();
		console.log("interstitialAd 游戏销毁插屏广告");
	};
		// 创建激励视频广告 展示一次创建一次
		// 参数
		//   adId: string 广告序号ID 游戏自定义
		//   videoAdId: string 视频广告ID 需后台申请
		//   screenOrientation: int 广告类型 1 横屏 2 竖屏
	window.HUHU_createRewardedVideoAd = function(){
		try{
			console.log("HUHU_createRewardedVideoAd:");
			HUHU.videoAd = AdSDK.createRewardedVideoAd("1", HUHU.videoId, HUHU.orientation);
			//注册onLoad函数,游戏调用创建视频时，AdSDK通知平台创建广告，当创建成功，会执行该回调函数通知游戏
			 HUHU.videoAd.onLoad(function () {
				 HUHU.videoAdLoaded=true;
				console.log("rewardedvideoAd 创建视频广告成功，可以调用展示")
			});
			//注册onError函数,游戏调用创建视频时，AdSDK通知平台创建广告，当创建失败，会执行该回调函数通知游戏
			 HUHU.videoAd.onError(function (param) {
				console.log("rewardedvideoAd 创建视频广告失败，错误码 = ", param.errorCode);
				 HUHU_destroyRewardedVideoAd();//加载广告失败，销毁
				 //HUHU_createRewardedVideoAd();
			});
			 //注册onClose函数,视频广告播放完整或主动退出观看视频时，展示落地页面，右上方关闭视频按钮触发，该函数执行。
			 HUHU.videoAd.onClose(function () {
				console.log("rewardedvideoAd 视频广告关闭,回到游戏页面");
				if(! HUHU.idRewarded){
				   console.log("需完整观看广告才能获取奖励");
				}
				 HUHU_destroyRewardedVideoAd();//视频广告关闭，销毁
				 HUHU_createRewardedVideoAd();//预加载
				
			});
			console.log("rewardedvideoAd 游戏创建视频广告");
		}catch(e){
			console.log(e);
		}
	};
	window.HUHU_showRewardedVideoAd = function(callback, failback){
		console.log("HUHU_showRewardedVideoAd:");
        window.getRewardVideo = callback;
        if(typeof(callback) == "function"){
            window.JSInterface && window.JSInterface.onRewardVideo && window.JSInterface.onRewardVideo("reward_Ad");
            // callback();
        }
        
		// if(HUHU.videoAdLoaded){
		// 	 HUHU.videoAd.show().then(function () {
		// 		// 大转盘转  奖励 // 标记  看完
		// 		console.log("rewardedvideoAd 广告显示成功，可以给与奖励")
		// 		HUHU.idRewarded=true;
		// 		if(typeof(callback) == "function"){
		// 			callback();
		// 		}
		// 	 }, function (err) {
		// 		console.log("rewardedvideoAd 广告显示失败")
		// 		//HUHU_createRewardedVideoAd();//预加载
		// 	 })
		// 	console.log("rewardedvideoAd 游戏展示视频广告");
		// }else{
		// 	// 视频未加载完，下发奖励   这个能屏蔽掉么
		// 	console.log("rewardedvideoAd 视频广告未加载成功");
		// //	HUHU_createRewardedVideoAd();//预加载
		// 	if(typeof(failback) == "function"){
		// 		failback();
		// 	}
		// }
	};
	window.HUHU_destroyRewardedVideoAd = function(){
		HUHU.videoAdLoaded = false;
		HUHU.idRewarded=false;
		HUHU.videoAd.destroy();
		console.log("rewardedvideoAd 游戏销毁视频广告");
	};
	window.HUHU_init();
	window.HUHU_createInterstitialAd();
	window.HUHU_createRewardedVideoAd();
})();